#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved. <<
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

## REQUIRES MySQL Version 3.23.23+  

#use FindBin;
#use lib $FindBin::Bin;
use CGI::Carp qw(fatalsToBrowser);
use CGI;
use DBI;
use acs;
use obbuild;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

##################################################################################

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "") {&do_search;}
if ($q->param('fct') eq "advanced") {&advanced;}
if ($q->param('fct') eq "advanced2") {&do_search;}
if ($q->param('fct') eq "setpage") {&setpage;}



##################################################################################

sub setpage
{

$v = $q->param('v');
acs::write_config("cp_search_listings", $v);

$headingd = acs::get_heading_box("$web_url/ic_settings3.gif", "Setting Updated", qq[Click here to <a href="javascript:onClick=window.close()">close</a> this window.]);

print qq[<html>
<head>
<title>Advanced Searching</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body onUnload="opener.location.reload(true);">
$headingd
</body>
</html>
];


}


sub advanced
{

$keydata = acs::get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$knr = @akeys;


foreach $k_item (@akeys)
		{
		($keyname, $visible, $size, $searched, $description1, $na, $imgk) = split (/\t/, $k_item);

		$kname = $keyname . "_cust";

		$extra_key_boxes = $extra_key_boxes . qq[<input type="checkbox" name="$kname" value="$kname" checked>$description1<BR>];
		}



print qq[<html>
<head>
<title>Advanced Searching</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>


<table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>
    <td bgcolor="#0000A0"><img src="$web_url/cpsearch.jpg"></td>
  </tr>
</table>
<div align="center"><center>

<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_ </font></td>
    <td width="99%"></td>
  </tr>
</table>
</center></div>

<form method="POST" action="$admin_url/admin11.cgi">
  <input type="hidden" name="fct" value="advanced2"><div align="center"><center><table
  border="0" cellpadding="6" cellspacing="1" width="100%"
  style="border: 1px solid rgb(219,219,219)">
    <tr>
      <td width="722" height="30" colspan="2" valign="top" background="$web_url/bar6.gif"
      class="normaltext"><strong>Advanced Search Options: </strong></td>
    </tr>
    <tr>
      <td width="159" valign="top" class="normaltext"><strong>Keywords: </strong></td>
      <td width="563" valign="top" class="normaltext"><input type="text" name="keywords"
      size="59" value> </td>
    </tr>
    <tr>
      <td width="159" valign="top" class="normaltext"><strong>Choose the fields you would like
      to be searched: </strong></td>
      <td width="563" valign="top" class="normaltext"><input type="checkbox" name="title"
      value="title" checked> Title <br>
      <input type="checkbox" name="diz" value="description" checked> Description <br>
      <input type="checkbox" name="keyw" value="keyw" checked> Keywords <br>
      <input type="checkbox" name="url" value="url" checked> URL <br>
      <input type="checkbox" name="name" value="name" checked> Name <br>
      <input type="checkbox" name="email" value="email" checked> Email <br>
      $extra_key_boxes </td>
    </tr>
    <tr>
      <td width="159" valign="top" class="normaltext"><strong>Match words Partially? </strong></td>
      <td width="563" valign="top" class="normaltext"><input type="checkbox" name="partialm"
      value="Y"> </td>
    </tr>
    <tr>
      <td width="159" valign="top" class="normaltext"><strong>Search with: </strong></td>
      <td width="563" valign="top" class="normaltext"><input type="radio" value="internal"
      name="mtype" checked> Determine the best matches for me. </td>
    </tr>
    <tr>
      <td width="159" valign="top" class="normaltext"></td>
      <td width="563" valign="top" class="normaltext"><input type="radio" value="andkeywords"
      name="mtype"> All the keywords supplied must match a link before it will be displayed as a
      match. </td>
    </tr>
    <tr>
      <td width="159" valign="top" class="normaltext"></td>
      <td width="563" valign="top" class="normaltext"><input type="radio" value="phrase"
      name="mtype"> Search with the exact phrase. (The phrase must match to find a match) </td>
    </tr>
    <tr>
      <td width="159" valign="top" class="normaltext"></td>
      <td width="563" valign="top" class="normaltext"><input type="submit" value="Search"
      name="B1"> </td>
    </tr>
  </table>
  </center></div><table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="99%"></td>
    </tr>
  </table>
</form>

</form>
</body>
</html>

];



}






sub do_search
{

$page_top = <<END_OF_SEARCHT;
<html>
<head>
<title>PowerSeek</title>

<script LANGUAGE="JavaScript">
<!-- Hide
var popupwin = null;
  function popup(loc,ww,hh)
   {
    var mywidth = (ww + 0);
    var myheight = (hh + 0);
    var winl = (screen.width-ww)/2;
	 var wint = (screen.height-hh)/2;
    
    var myspecs = 'menubar=0,status=1,resizable=1,location=0,titlebar=1,toolbar=1,scrollbars=1,width=' + mywidth + ',height=' + myheight + ',top=' + winl + ',left=' + wint;
      if (popupwin == null || popupwin.closed)
			{
            popupwin = window.open (loc, 'popupwin', myspecs);
           }
		 else
		   {
            popupwin.focus();
            popupwin.location.href = loc;
          }
    }


function checkall(formname,thestate)
	{
	BoxNames=new Array(!!sel_options!!)
	for (c=0;c < BoxNames.length; c++)
		{
		boxname = eval("document." + formname + "." + BoxNames[c])
		boxname.checked = thestate
		}
	}


function submitForm(theForm, selv) 
  {
  BoxNames=new Array(!!sel_options!!)
  windowName = "PowerSeek";
  windowURL = theForm.action + '?';
  var c = 0;
	for (c=0;c < BoxNames.length; c++)
		{
		chvl = eval("theForm." + BoxNames[c] + ".checked");
		if (chvl)
			{
			boxnm = eval("theForm." + BoxNames[c] + ".value");
			windowURL = windowURL + BoxNames[c] + '=' + boxnm + '&';
			}
		}
    windowURL = windowURL + 'itemnrs=!!itemnrs!!&';
    
    if (selv == 1)
    	{
    	windowURL = windowURL + 'dropdown=' + theForm.dropdown1.value;
    	}
    	else
    	{
    	windowURL = windowURL + 'dropdown=' + theForm.dropdown.value;
    	}

    
    
    if (theForm.dropdown1.value == 'Delete')
    	{
    	var shih = 150;
    	var swid = 600;
    	var winl = 200;
    	var wint = 200;
    	}
    	else
    	{
    	var shih = screen.height-250;
    	var swid = screen.width-250;
	   var winl = (screen.width-swid)/2;
		var wint = (screen.height-shih)/2;
    	}

    var myspecs = 'menubar=0,status=1,resizable=1,location=0,titlebar=1,toolbar=1,scrollbars=1,width=' + swid + ',height=' + shih + ',top=' + winl + ',left=' + wint;
    var popupwin = null;
    
    var random = parseInt(Math.random()*10000)
    
    myWindow = window.open(windowURL, 'popupwin' + random, myspecs);
    myWindow.focus();
  } 

// End Hide -->
</script>


<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>
END_OF_SEARCHT




$keywords = $q->param('keywords');

if ($keywords eq "")
	{
	  acs::problem_popup("You have to provide keywords to search for.");  
	}


$keywords =~ s/\\//g;

### CONNECT TO DB

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


### GET EXTRA KEYS/FIELDS 

    push(@fields_to_search, "title"); 
    push(@fields_to_search, "diz"); 
    push(@fields_to_search, "keyw"); 
    push(@fields_to_search, "url"); 
    push(@fields_to_search, "name"); 
    push(@fields_to_search, "email"); 



$keydata = acs::get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$knr = @akeys;

foreach $kitem (@akeys)
	{
	($keyname, $visible, $size, $searched, $description, $na, $imgk, $nmbr) = split (/\t/, $kitem);
	
	push(@fields_to_search, "$keyname" . "_cust"); 
	
	if (($searched eq "Yes") and ($imgk ne "Yes") and ($nmbr ne "Y"))
		{
		$full_texti = $full_texti . ",A." . $keyname . "_cust";
		}
	
	}


### PREPARE SQL QUERY

$keywords =~ s/'/\\'/g;


if ($q->param('fct') ne "advanced2")
	{

$sql = "SELECT B.l1, B.l2, B.l3, B.l4, B.l5, B.l6, B.l7, B.l8, B.l9, B.l10, B.l11, B.l12, B.l13, B.l14, B.l15, B.l16, B.cid, A.*,
	       MATCH (A.title,A.description,A.keywords,A.url,A.email $full_texti) AGAINST ('$keywords') AS SCORE 
			 FROM links AS A,
		       dirs AS B 
		       WHERE (MATCH (A.title,A.description,A.keywords,A.url,A.email $full_texti) AGAINST ('$keywords'))
		       AND (A.cid = B.cid) ORDER BY SCORE DESC";

	 }
	 else ### DO ADVANCED SEARCH
	 {
	 
	 $mtype = $q->param('mtype');
	 $partialm = $q->param('partialm');
    


			foreach $search_field (@fields_to_search)
				{
				
						if ($q->param($search_field) ne "")	
						{

							$pass_on_string = $pass_on_string . $search_field . "=" . $search_field . "&";
						
						
							if ($search_field eq "diz") { $search_field = "description"; }
							if ($search_field eq "keyw") { $search_field = "keywords"; }
						
						if ($q->param('partialm') eq "Y")
							{
							$sql_fields_to_search = $sql_fields_to_search . " (A.$search_field like '%!!keyw!!%') OR";
							}
							else
							{
							$sql_fields_to_search = $sql_fields_to_search . " (A.$search_field RLIKE '[[:<:]]!!keyw!![[:>:]]') OR";
							}
						}
				}
				
						if ($sql_fields_to_search eq "") { acs::problem_popup("You have to select at least one field to be searched.");  }
						$sql_fields_to_search = substr($sql_fields_to_search, 0, length($sql_fields_to_search) -2);


	 if (($q->param('mtype') eq "internal") or  ($q->param('mtype') eq "andkeywords"))
	 	{

		
			@keyword_items = split (/ /, $q->param('keywords'));
			
			foreach $one_keyword (@keyword_items)
				{
				$tmpsql_str = $sql_fields_to_search;
				$tmpsql_str =~ s/!!keyw!!/$one_keyword/gi;
					
					if ($q->param('mtype') eq "andkeywords")
						{
						$sql_where_string = $sql_where_string . " ($tmpsql_str) AND";
						}
						else
						{
						$sql_where_string = $sql_where_string . " ($tmpsql_str)  OR";
						}
				}
				$sql_where_string = substr($sql_where_string, 0, length($sql_where_string) - 3);
		
		
		
		$sql = "SELECT B.l1, B.l2, B.l3, B.l4, B.l5, B.l6, B.l7, B.l8, B.l9, B.l10, B.l11, B.l12, B.l13, B.l14, B.l15, B.l16, B.cid, A.*
			    FROM links AS A, dirs AS B 
		       WHERE ($sql_where_string)
		       AND (A.cid = B.cid)";
		  
	 	}
	 	else ### PHRASE MATCH
	 	{

		$sql_fields_to_search =~ s/!!keyw!!/$keywords/g;

		$sql = "SELECT B.l1, B.l2, B.l3, B.l4, B.l5, B.l6, B.l7, B.l8, B.l9, B.l10, B.l11, B.l12, B.l13, B.l14, B.l15, B.l16, B.cid, A.*
			    FROM links AS A, dirs AS B 
		       WHERE ($sql_fields_to_search)
		       AND (A.cid = B.cid) ";

	
		
	 	}
	 	
	 	#print "--> $sql <BR>";

	 }

###########
	
$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
$rows = $sth->rows();


### PREPARE PAGES

$gsettings = new_gsettings acs; 


$icnt = $rows;
$nr_searchres = $gsettings->{cp_search_listings};
#$nr_searchres = 10;

$modp = ($icnt % $nr_searchres);
$pages = ($icnt - $modp) / $nr_searchres;
if ($modp != 0) {$pages++;}

$st = $q->param('st');
$nd = $q->param('nd');
if ($st eq ""){$st = 0;}
if ($nd eq ""){$nd = $nr_searchres;}

$ippc = 1;




############

$page_middle = <<END_OF_SRB;


<table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>
    <td width="100%" bgcolor="#0000A0"><img src="$web_url/cpsearch.jpg"></td>
  </tr>
</table>
<div align="center"><center>

<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
    <td width="99%"></td>
  </tr>
</table>
</center></div>

<form method="POST" action="$admin_url/admin11.cgi">

<table border="0" cellpadding="6" cellspacing="1" width="100%"
style="border: 1px solid rgb(215,215,215)">
  <tr>
    <td width="100%" valign="top" background="$web_url/bar6.gif" align="center" colspan="2"><span class="normaltext"><b>Search Again:</b></span> <input
    type="text" name="keywords" size="58" value="$keywords" style="width:50%"> <input
    type="submit" value="Search Again" name="B1"> <strong><a
    href="$admin_url/admin11.cgi?fct=advanced"><span class="normaltext">Advanced</span></a></strong></td>
  </tr>
  <tr>
    <td width="32%"><span class="normaltext">Number of Matches:<strong> $rows</strong></span></td>
    <td width="68%" align="right"><span class="normaltext">!!pagecrit1!!</span></td>
  </tr>
  <tr>
    <td width="100%" colspan="2"><span class="normaltext">!!pagecrit2!!</span></td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
    <td width="99%"></td>
  </tr>
</table>


  
</form>


<span class="normaltext">

END_OF_SRB




$nowtime = time();

$form_c_counter = 0;
$c_counter = 0;
$printcrit = "";
$highnr = 0; $bcnt = 0;
while ( @row = $sth->fetchrow() )
	{
	if ($highnr == 0){$high_number = $row[44 + $knr];}
	$highnr++;
	
	if (($ippc > $st) and ($ippc <= $nd))
    {
		$cats = "";
		for ($ms = 0; $ms < 16; $ms++) 
			{
			if ($row[$ms] ne "")
				{
				$cats = $cats . $row[$ms] . "/";
				}
			}
			
				$cbname = "C" . $c_counter;
				$cb_val = $row[17] . "-" . $row[16];
				$cbox = "<input type=\"checkbox\" name=\"$cbname\" value=\"$cb_val\">";
				$c_counter++;
			
			
			if (($row[38] == 0) and ($row[30] > 0))
			{ $row[38] = 99999999999999; }

			$premimg = ""; $expires = "";
			if (($row[30] > 0) and ($row[38] > $nowtime))### IF PREMIUM LINK
				{
				$premimg = qq[<BR><img src="$web_url/premi2.gif">];
				
					if (($row[38] != 0) and  ($row[38] != 99999999999999))
						{
						$expdate = acs::decode_date($row[38]);
						$expires = qq[<BR><font color="#FF0000"><b>Expires: $expdate</b></font>];
						}
						else
						{
						$expires = qq[<BR><font color="#FF0000"><b>Never Expires</b></font>];
						}
				}

			$printcrit = $printcrit . qq[<table border="0" cellpadding="6" cellspacing="0" width="100%"><tr><td width="1%" valign="top">$cbox $premimg</td><td width="99%" class="normaltext">
			<b>$ippc. <a href="$row[22]" target="_blank">$row[19]</a></b><BR>
			$row[20]<BR>
			<b>$row[22]</b><BR>];
			

			#### EXTRA KEYS/FIELDS
			$field_key_count = 44;
			foreach $kitem (@akeys)
				{
				($keyname, $visible, $size, $searched, $description, $na, $imgk, $nmbr) = split (/\t/, $kitem);
				
				if (($visible eq "Yes") and ($nmbr eq "Upload"))
					{
					if ($row[$field_key_count] ne "") 
						{
						$ifname = "$web_url/imagefiles/$row[17]/$keyname" . "." . $row[$field_key_count];
						$printcrit = $printcrit . qq[<font color="#804040"><b>$description:</b></font> <a href="$ifname" target="_blank">$ifname</a><BR>];
						}
						else
						{
						$printcrit = $printcrit . qq[<font color="#804040"><b>$description:</b> N/A</font><BR>];
						}
					}
				elsif (($visible eq "Yes") and ($imgk ne "Yes"))
					{
						$printcrit = $printcrit .  "<b><font color=\"#8080C0\">$description:</font></b> $row[$field_key_count]<br>";
					}
				elsif (($imgk eq "Yes") and ($visible eq "Yes"))
					{
						if ($row[$field_key_count] ne "")
						{
						$printcrit = $printcrit .  "<img src=\"$row[$field_key_count]\"><br>";
						}
					}
					
				$field_key_count++;
				}
				

			##### GET CATEGORY

			$ecat = "";
			@acts = split (/\//, $cats);
			foreach $citem (@acts)
				{
				$ecat = $ecat . acs::encode_dir($citem) . "-";
				}
			chop($ecat);

			$printcrit = $printcrit . "<b>ID: $row[17]</b>$expires<BR>";

			$printcrit = $printcrit .  "<big><img src=\"$web_url/dir.gif\"> </big><a href=\"$admin_url/admin12.cgi?ct=$ecat&fct=gotocat&cid=$row[18]&C0=$row[17]\" 
			onClick=\"self.opener.location='$admin_url/admin12.cgi?ct=$ecat&fct=gotocat&cid=$row[18]&C0=$row[17]'; self.opener.focus(); return false;\">From: $cats</a><BR>";
			
			## GET RELEVANCE
			if ($q->param('fct') ne "advanced2") 
			{
			
				if ($row[44 + $knr] > 0)
					{
					$perc = $row[44 + $knr] / $high_number * 100;
					}
					else
					{
					$perc = 0;
					}

				$perc = sprintf("%5.2f",$perc);
				
				if (int($perc) == 100) { $perc = "99.99"; }
				
				$rgraphic = "";
				
				if ($perc < 100) { $rgraphic = "<img src=\"$web_url/100.gif\">"; }
				if ($perc < 91) { $rgraphic = "<img src=\"$web_url/90.gif\">"; }
				if ($perc < 81) { $rgraphic = "<img src=\"$web_url/80.gif\">"; }
				if ($perc < 71) { $rgraphic = "<img src=\"$web_url/70.gif\">"; }
				if ($perc < 61) { $rgraphic = "<img src=\"$web_url/60.gif\">"; }
				if ($perc < 51) { $rgraphic = "<img src=\"$web_url/50.gif\">"; }
				if ($perc < 41) { $rgraphic = "<img src=\"$web_url/40.gif\">"; }
				if ($perc < 31) { $rgraphic = "<img src=\"$web_url/30.gif\">"; }
				if ($perc < 21) { $rgraphic = "<img src=\"$web_url/20.gif\">"; }
				if ($perc < 11) { $rgraphic = "<img src=\"$web_url/10.gif\">"; }
				
				$relg = "<big>$rgraphic </big><b>Relevance:</b> $perc %<br>";
			}
			

			$user_account_jump = "";
			if ($row[33] > 0) ### IF USER ACCOUNT EXISTS FOR LINK
				{
				$user_account_jump = qq[<b>[<a href="$admin_url/admin55.cgi?fct=editacc&userid=$row[33]" onClick="popup('$admin_url/admin55.cgi?fct=editacc&userid=$row[33]',750,600);return false;">User Account</a>]</b>];
				}


$printcrit = $printcrit . <<END_OF_EDIT;
[<a href="$admin_url/admin12.cgi?ct=$ecat&fct=Edit&cid=$row[18]&C0=$row[17]" onClick="popup('$admin_url/admin12.cgi?ct=$ecat&fct=Edit&cid=$row[18]&C0=$row[17]',screen.width-250,screen.height-250);return false;">Edit</a>] 
[<a href="$admin_url/admin12.cgi?ct=$ecat&fct=Move&cid=$row[18]&C0=$row[17]" onClick="popup('$admin_url/admin12.cgi?ct=$ecat&fct=Move&cid=$row[18]&C0=$row[17]',screen.width-250,screen.height-250);return false;">Move</a>] 
[<a href="$admin_url/admin12.cgi?ct=$ecat&fct=Copy&cid=$row[18]&C0=$row[17]" onClick="popup('$admin_url/admin12.cgi?ct=$ecat&fct=Copy&cid=$row[18]&C0=$row[17]',screen.width-250,screen.height-250);return false;">Copy</a>]

END_OF_EDIT
		
			$scroe = $row[44 + $knr];
			$printcrit = $printcrit .  "[<a href=\"$admin_url/admin12.cgi?ct=$ecat&fct=Delete&cid=$row[18]&C0=$row[17]&del_only_one=true\" onClick=\"popup('$admin_url/admin12.cgi?ct=$ecat&fct=Delete&cid=$row[18]&C0=$row[17]&del_only_one=true',600,150);return false;\">Delete</a>] $user_account_jump<Br>";
			$printcrit = $printcrit .  $relg . "<BR></td></tr></table>";


		 $form_c_counter++;
		}
	$ippc++;
	}



$sth->finish;
$dbh->disconnect;

if (($rows < 1) and ($q->param('fct') ne "blinks"))
	{
	$printcrit = $printcrit .  qq[
<table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#DBDBDB"
height="46">
  <tr>
    <td width="100%" bgcolor="#FFFFFF" height="30" align="center"><p align="center"><strong>No
    matches found. </strong>Try using more or different keywords. Note that if you have <br>
    only a handfull of links then the search won't function correctly. You need more or less
    50 links. </td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
    <td width="99%"></td>
  </tr>
</table>


	];
	}



#### PAGES 
$fct= $q->param('fct');

for ($ms = 0; $ms < $pages; $ms++) 
	{
	$pg = $ms + 1;
	if ($nd == ($pg * $nr_searchres))
		{
		$pgstring = $pgstring . " [$pg] ";
		$targpage = $pg;
		}
	  	else
		{
		$st1 = ($pg * $nr_searchres) - $nr_searchres;
		$nd1 = ($pg * $nr_searchres);
		
		
		$pgstring = $pgstring . "<a href=\"$admin_url/admin11.cgi?st=$st1&nd=$nd1&keywords=$keywords&fct=$fct&mtype=$mtype&partialm=$partialm&$pass_on_string\">$pg</a> ";
		}
	}

if ($pages > 1)
	{
	$pgstring = "Pages: " . $pgstring;
	}
	else
	{
	$pgstring = "";
	}

$page_crit = $page_crit .  $pgstring;


### PREV NEXT PAGES

$spls = $modp;
if ($spls == 0){$spls++;}

 if ($nd <= ($icnt - $spls))
 	{
	$st1 = $st + $nr_searchres;
	$nd1 = $nd + $nr_searchres;
	$nextt = "<a href=\"$admin_url/admin11.cgi?st=$st1&nd=$nd1&keywords=$keywords&fct=$fct&mtype=$mtype&partialm=$partialm&$pass_on_string\">Next Page >></a> ";
	}

 if ($st > 0)
	 	{
		$st1 = $st - $nr_searchres;
		$nd1 = $nd - $nr_searchres;
		$prev = "<a href=\"$admin_url/admin11.cgi?st=$st1&nd=$nd1&keywords=$keywords&fct=$fct&mtype=$mtype&partialm=$partialm&$pass_on_string\"><< Prev Page</a> ";
		}

if (($prev ne "") and ($nextt ne ""))
	{
	$spcer = " | ";
	}
	else
	{
	$spcer = " ";
	}
	  
	$prevnext = $prev . "$spcer" . $nextt;

	if (length($prevnext) > 5){$myspacer = " | ";}

if ($rows > 0)
	{
	$page_crit2 = $page_crit2 .  "$prevnext $myspacer Page $targpage of $pg";
	}

$printcrit = $printcrit .  "</span>";





if ($rows > 0)
		{

if ($nr_searchres == 10) { $v10 = "selected"; }
if ($nr_searchres == 20) { $v20 = "selected"; }
if ($nr_searchres == 30) { $v30 = "selected"; }
if ($nr_searchres == 40) { $v40 = "selected"; }
if ($nr_searchres == 50) { $v50 = "selected"; }
if ($nr_searchres == 75) { $v75 = "selected"; }
if ($nr_searchres == 100) {$v100 = "selected"; }
if ($nr_searchres == 200) {$v200 = "selected"; }
if ($nr_searchres == 500) { $v500 = "selected"; }
if ($nr_searchres == 1000) { $v1000 = "selected"; }

$print_crit_form = qq[

<form name="select_all" method="POST" action="$admin_url/admin56.cgi">
<input type="hidden" name="itemnrs" value="$c_counter">

<table border="0" cellpadding="5" cellspacing="0" width="100%">
  <tr>
    <td width="50%" class="normaltext"><select name="dropdown1" size="1"
    style="font-family: MS Sans Serif; font-size: 8pt">
      <option value="Edit">Edit Checked Items</option>
      <option value="Move">Move Checked Items</option>
      <option value="Copy">Copy Checked Items</option>
      <option value="Delete">Delete Checked Items</option>
    </select><input type="submit" value="Submit" name="B1"
    style="font-family: MS Sans Serif; font-size: 8pt"
    onClick="submitForm(document.select_all,1); return false;"> <a
    href="javascript:checkall('select_all',true)">Check All</a> | <a
    href="javascript:checkall('select_all',false)">UnCheck All</a> </td>
    <td width="50%" class="normaltext" align="right"><select name="listperpage1" size="1"
    style="font-family: MS Sans Serif; font-size: 8pt">
      <option $v10 value="10">List 10 Links Per Page</option>
      <option $v20 value="20">List 20 Links Per Page</option>
      <option $v30 value="30">List 30 Links Per Page</option>
      <option $v40 value="40">List 40 Links Per Page</option>
      <option $v50 value="50">List 50 Links Per Page</option>
      <option $v75 value="75">List 75 Links Per Page</option>
      <option $v100 value="100">List 100 Links Per Page</option>
      <option $v200 value="200">List 200 Links Per Page</option>
      <option $v500 value="500">List 500 Links Per Page</option>
      <option $v1000 value="1000">List 1000 Links Per Page</option>
    </select><input type="submit" value="   Go   " name="ppga"
    style="font-family: MS Sans Serif; font-size: 8"
    onClick="popup('$admin_url/admin11.cgi?fct=setpage&v=' + listperpage1.value,600,110);return false;"
    
    ></td>
  </tr>
</table>


<hr size="1" color="#E8E8E8">
  
	];
	
	
	
$printcrit = $print_crit_form . $printcrit . qq[

<hr size="1" color="#E8E8E8">

<table border="0" cellpadding="5" cellspacing="0" width="100%">
  <tr>
    <td width="100%" class="normaltext"><select name="dropdown" size="1"
    style="font-family: MS Sans Serif; font-size: 8pt">
      <option value="Edit">Edit Checked Items</option>
      <option value="Move">Move Checked Items</option>
      <option value="Copy">Copy Checked Items</option>
      <option value="Delete">Delete Checked Items</option>
    </select><input type="submit" value="Submit" name="B1"
    style="font-family: MS Sans Serif; font-size: 8pt"
    onClick="submitForm(document.select_all,0); return false;"> <a
    href="javascript:checkall('select_all',true)">Check All</a> | <a
    href="javascript:checkall('select_all',false)">UnCheck All</a> </td>
  </tr>
</table>

<table border="0" cellpadding="6" cellspacing="0" width="100%">
  <tr>
    <td width="50%" class="normaltext">$page_crit2</td>
    <td width="50%" align="right" class="normaltext">$page_crit</td>
  </tr>
</table>
<hr size="1" color="#E8E8E8">
<BR>
];
		}



$printcrit = $printcrit . "</body></html>";


### FILL JAVASCRIPT VARS

for ($ms = 0; $ms < $form_c_counter; $ms++) 
	{
	$sel_options = $sel_options . "'C" . $ms . "',";
	}
	$sel_options = substr($sel_options, 0, length($sel_optionss) - 1);

$page_top =~ s/!!sel_options!!/$sel_options/gi;
$page_top =~ s/!!itemnrs!!/$form_c_counter/gi;

$page_middle =~ s/!!pagecrit1!!/$page_crit/gi;
$page_middle =~ s/!!pagecrit2!!/$page_crit2/gi;

print $page_top . $page_middle . $printcrit;
}




####################################################################################

sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

